/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:RulesManagerModelLocator.as 2485 2008-09-30 14:14:35Z nicoulaj $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.autonomous.cairngorm.model
{
	
	import com.adobe.cairngorm.model.ModelLocator;
	
	import org.ow2.jasmine.monitoring.eos.autonomous.cairngorm.business.*;
	import org.ow2.jasmine.monitoring.eos.autonomous.cairngorm.model.domain.*;
	import org.ow2.jasmine.monitoring.eos.autonomous.cairngorm.model.presentation.*;
		
	/**
	* Cairngorm Model Locator for the autonomous module
	* 
	* @author Julien Nicoulaud
	*/
	[Bindable]
	public class AutonomousModelLocator implements ModelLocator 
	{
        // =====================================================================
        // Variables
        // =====================================================================
                
        /**
        * Singleton instance of this locator
        */
		private static var instance:AutonomousModelLocator;
		
		
        // Models
        
        /**
        * Module main domain model
        */
        public var autonomousModel:AutonomousModel;
        
        /**
        * Module main presentation model
        */
        public var autonomousPresentationModel:AutonomousPM;
        

        // Command delegates unique instances
        
        // None yet
        

        // =====================================================================
        // Construction and singleton instance access
        // =====================================================================
        
        /**
        * Constructor
        */
		public function AutonomousModelLocator()
		{
			// Instanciate the singleton
			if(instance!=null) {
				throw new Error("Error: Singletons can only be" + 
								"instantiated via getInstance() method!");
			}
			AutonomousModelLocator.instance = this;
		}
		
		/**
		* AutonomousModelLocator singleton instance getter
		*/
		public static function getInstance():AutonomousModelLocator
		{
			if(instance==null){
                
                // Instanciate the ModelLocator
                instance = new AutonomousModelLocator();
                
                // Instanciate the models
                instance.autonomousModel = new AutonomousModel();
                instance.autonomousPresentationModel = new AutonomousPM(instance.autonomousModel);
                
            }
			return instance;
		}
		
		
        // =====================================================================
        // Delegates getters
        // =====================================================================
        
        // None yet
        
	}
}